<script setup lang="ts">
import gsap from 'gsap';
import ScrollTrigger from 'gsap/ScrollTrigger';

// Import Lucide Icons
import { Menu, Home, Files } from 'lucide-vue-next';

// Register GSAP ScrollTrigger (Client-side only)
if (typeof window !== 'undefined') {
  gsap.registerPlugin(ScrollTrigger);
}

// Refs for buttons & card
const buttons = ref<HTMLElement[]>([]);
const cardRef = ref<HTMLElement | null>(null);
const router = useRouter();

// Button Data with Lucide Icons
const buttonData = [
  { title: 'GitHub', route: 'http://github.com/devhardiyanto', icon: 'ri-github-line' },
  { title: 'Instagram', route: 'https://www.instagram.com/dev.hardiyanto', icon: "ri-instagram-line" },
  { title: 'Twitter (X)', route: 'https://x.com/dev_hardiyanto', icon: 'ri-twitter-x-line' },
  { title: 'Download CV', route: '/irfan-resume-2025.pdf', icon: 'ri-file-text-line' } // CV icon
];

// Button Data with Lucide Icons
const buttonProject = [
  { title: 'Menu', route: '#', icon: Menu },
];

// Function to set ref for buttons
const setButtonRefs = (el: HTMLElement) => {
  if (el) buttons.value.push(el);
};

// GSAP Animation on Scroll
onMounted(async () => {
  if (typeof window === 'undefined') return;
  await nextTick(); // Ensure DOM is fully loaded

  // Check if GSAP is available
  if (!gsap || typeof gsap.from !== 'function') {
    console.error("GSAP is not available. Check your imports and registration.");
    return;
  }

  // GSAP Animation for Button Fade-in
  gsap.from(buttons.value, {
    y: -50,
    opacity: 0,
    duration: 0.5,
    stagger: 0.15,
    ease: 'back.out(1.7)',
  });
});
</script>

<template>
  <div class="flex flex-col space-y-4">
    <Card id="sticky-card" class="w-fit shadow-md rounded-lg bg-neutral-50 dark:bg-neutral-900 dark:shadow-lg">
      <CardContent class="p-2 flex flex-col space-y-1">
        <TooltipProvider v-for="(item, index) in buttonData" :key="index">
          <Tooltip :delay-duration="50">
            <TooltipTrigger as-child>
              <Button
                variant="outline"
                size="icon"
                class="p-2 hover:bg-neutral-200 dark:hover:bg-neutral-800"
                as="a"
                :ref="el => { if (el && '$el' in el) buttons[index] = el.$el as HTMLElement }"
                :href="item.route" target="_blank">
                <i :class="item.icon" class="size-5" />
                <!-- <component :is="item.icon" class="w-5 h-5" /> -->
              </Button>
            </TooltipTrigger>
            <TooltipContent align="center" side="right">
              <p class="text-xs">{{ item.title }}</p>
            </TooltipContent>
          </Tooltip>
        </TooltipProvider>
      </CardContent>
    </Card>

    <Card id="sticky-card" class="w-fit shadow-md rounded-lg bg-neutral-50 dark:bg-neutral-900 dark:shadow-lg">
      <CardContent class="p-2 flex flex-col space-y-1">
        <DropdownMenu>
          <DropdownMenuTrigger as-child>
            <Button
              variant="outline"
              size="icon"
              class="p-2 hover:bg-neutral-200 dark:hover:bg-neutral-800"
              :ref="el => { if (el && '$el' in el) buttons.push(el.$el) }">
              <Menu class="w-5 h-5" />
            </Button>
          </DropdownMenuTrigger>
          <DropdownMenuContent align="start" side="right" :side-offset="5" class="w-44">
            <DropdownMenuGroup>
              <DropdownMenuItem as-child class="hover:cursor-pointer">
                <NuxtLink to="/">
                  <Home class="w-5 h-5" /> Home
                </NuxtLink>
              </DropdownMenuItem>
            </DropdownMenuGroup>
            <DropdownMenuSeparator />
            <DropdownMenuLabel>Interactive Pages</DropdownMenuLabel>
            <DropdownMenuSeparator />
            <DropdownMenuGroup>
              <DropdownMenuItem as-child class="hover:cursor-pointer">
                  <NuxtLink to="/personal-dashboard">
                  <Files class="w-5 h-5" /> Personal Dashboard
                </NuxtLink>
              </DropdownMenuItem>
            </DropdownMenuGroup>
          </DropdownMenuContent>
        </DropdownMenu>
      </CardContent>
    </Card>
  </div>
</template>
